/* --------------------------------------------------------------
     ᫠  ࠭祭 ࠧ來 ⪮.
    -뢮.

    http://www.imach.uran.ru/cbignum

    Copyright 1999-2003, ..஢,   PAH.
    All Rights Reserved.

     ।⠢  ᫮ 業 "public domain",
    .. ᪠ ᢮ ਬ, 䨪 
    ࠭   ᫮ ࠭ ࠩ
      ᢥ   ᥭ .

           .
        "AS IS"  - 
         .
-------------------------------------------------------------- */
#if __TURBOC__ > 0x410
#pragma option -xd-
#endif
#include <assert.h>
#include <ctype.h>
#include <stdlib.h>
#include <iomanip.h>
#include <limits.h>
#include "Cbignum.h"

//================================================
//      .
//================================================

//      ᨬ쭮 ᭮ ⥯.

#define MAX_RADIX 16

//       ࠧ ᫠  ,  /뢮
//      ண  ண-.

#define MIN_PROGR 10

//       ४஢ .

static const char numtochar [2] [MAX_RADIX + 1] =
                               {{'0','1','2','3','4','5','6','7','8','9',
                                 'a','b','c','d','e','f','x'},
                                {'0','1','2','3','4','5','6','7','8','9',
                                 'A','B','C','D','E','F','X'}};

//       ४஢  (樠 cBigNumberSqrTab)

static char chartonum [UCHAR_MAX + 1] = { 0 };

//       ⠡ 樥⮢   ᭮ 뢠
//      ᨬ쭠 楫᫥ ⥯ ⨯ long  ᫮ 
//       ப ।⠢ ⮩ ⥯.

static const long maxradix [] [4] = {{ 0L,  1},     //  0
                                     { 1L,  1},     //  1
                            { 1073741824L, 30},     //  2
                            { 1162261467L, 19},     //  3
                            { 1073741824L, 15},     //  4
                            { 1220703125L, 13},     //  5
                            {  362797056L, 11},     //  6
                            { 1977326743L, 11},     //  7
                            { 1073741824L, 10},     //  8
                            {  387420489L,  9},     //  9
                            { 1000000000L,  9},     // 10
                            {  214358881L,  8},     // 11
                            {  429981696L,  8},     // 12
                            {  815730721L,  8},     // 13
                            { 1475789056L,  8},     // 14
                            {  170859375L,  7},     // 15
                            {  268435456L,  7} };   // 16

//       ⨬樨 /뢮  ᥫ  
//      ᭮ ᮧ ᨢ  १⠬ ᫥⥫쭮
//       室 樥  .  
//      祭 樥 ନ ⠡ ᤢ.
//      ᨬ 樥 MAX_NP ।  
//      樨 ६ /뢮 ᥫ ࠧ୮ 
//      1,000,000      襬 ࠧ >256.

#define MAX_NP_IN  ((sizeof(size_t))==2? 2: 9)
#define MAX_NP_OUT ((sizeof(size_t))==2? 2: 9)
#define MAX_NP    (MAX_NP_IN>MAX_NP_OUT?MAX_NP_IN:MAX_NP_OUT)

static exarray<cBigNumber> powradix [MAX_RADIX + 1];

//       ⠡ ४஢  ᨢ 樥⮢.
//       ⠡ 易⥫쭮   訩 樥 
//       .

static  size_t  cBigNumberSqrTab (
                unsigned radix,         // ᭮ (2..16).
                size_t len,             // ᫮ ᫮  ᫥.
                size_t max_np           // ᨬ 樥.
)                                       // 뤠 ॡ㥬 ᫮
{                                       // 樥⮢ (0..MAX_NP).
  assert (radix >= 2);
  assert (radix <= MAX_RADIX);
  assert (max_np <= MAX_NP);
  static size_t npow [MAX_RADIX + 1];   // ᫮ 樥⮢.

  if (npow [radix] == 0)
  {
//       ४஢.

    int i;
    for (i = 0; i <= UCHAR_MAX; i++)
    {
      chartonum [i] = MAX_RADIX;
    }
    for (i = 0; i < MAX_RADIX; i++)
    {
      chartonum [numtochar [0] [i]] = (char)i;
      chartonum [numtochar [1] [i]] = (char)i;
    }

//      訩 樥   .

    powradix [radix] [0] = maxradix [radix] [0];
    powradix [radix] [0].tab();         //  ᤢ.
    powradix [radix] [1] = maxradix [radix] [0];
    powradix [radix] [1].pow2();        // .
    powradix [radix] [1].tab();         //  ᤢ.
    npow [radix] = 2;                   // ⠥ 樥.
  }

//      訥 樥, ᫨ ॡ.

  size_t np = 0;                        //  ⥪饣 樥.
  while (np < max_np && powradix [radix] [np].length() * 4 < len)
  {
    if (++np >= npow [radix])
    {
      powradix [radix] [np] = powradix [radix] [np - 1];
      powradix [radix] [np].pow2();     //  樥.
      powradix [radix] [np].tab();      //  ᤢ.
      ++ npow [radix];                  // ⠥ 樥.
    }
  }
  assert (np <= max_np);
//cerr << np << endl;
  return np;
}

//      稥 .

static cBigNumber        num_;          //  ᫮.
static cBigNumber        mod_;          // ⮪ .
static exvec<cBigNumber> stk_(MAX_NP);  // ⥪ ஬ ᥫ.
static exvec<int>       kstk_(MAX_NP);  // ⥪ ਧ.

//================================================
//       ॢ ப  ᫮.
//================================================

//      ⮤ ॢ ᨬ쭮 ᨢ  
//       ᫮ ࠡ⠥  ᭮  2  16.

cBigNumber& cBigNumber::set_ (          // ८ࠧ  ᨢ.
                const EXPTR(char) ps,   // ᨢ.
                unsigned radix,         // ᭮ (2..16).
                unsigned len            //  ᨢ.
            )
{
  assert (ps);
  assert (radix >= 2);
  assert (radix <= MAX_RADIX);

//       ᫠.
//
//      室 (⨬஢)  룫廊 ⠪:
//      *this = 0;
//      for (; len > 0; --len)
//      {
//        *this *= radix;
//        *this += chartonum [*ps++];
//      }
//
//       ⨬஢ ⬥  㬭 ਬ
//      ⮤ addmultab, 믮騩 㬭  .
//       ᮪饭 ᫠  㬭 ਬ
//      㬭  樥 powradix, 祭 ⥬
//       ᭮ radix  楫o᫥ ⥯.
//       ஬ 㬭  
//        ᫥ num_   ⥪ ⥫ mul.
//      ࢮ砫쭮 ⥪ .
//
//      
//      ⥫ 㫥 浪 ।⠢  ᫮
//        ⥬ ८ࠧ ⪨ 楯祪.
//      ⥫ i- 浪 砥 ⥬ ꥤ 
//      addmultab  ᫥⥫ ⥫ 浪 i-1,
//           mul [i].
//      饥 ᫮ 砥 ⥬ ᫥⥫쭮
//      ꥤ  addmultab 襣 ⥫  num_.

  *this = 0;
  if (len != 0)
  {
    long lradix =       maxradix [radix] [0];
    int  nradix = (int) maxradix [radix] [1];
    int nr = (len - 1) / nradix;        // ᫮  ᫮ ( ).
    int n = len - nr++ * nradix;        // ᫮ ᨬ   ᫮.

//       ⥪ 樥⮢ powradix [radix].
//      뤠 ॡ㥬 ᫮ 樥⮢.

    size_t np = cBigNumberSqrTab (radix, nr, MAX_NP_IN);
    EXPTR(cBigNumber) powr = EXPTRTYPE(powradix [radix]);

//      㫥 ⥪ ⥫.

    EXPTR(cBigNumber)  mul = EXPTRTYPE(stk_);   // ⥪ ⥫.
    { for (size_t i = 1; i < np; i++) mul [i] = 0; }

//      ண - .

    int numlength = nr / (1024 / sizeof (long));
    if (numlength < MIN_PROGR) numlength = 0;   //   .
    if (numlength > 0)
    {
      cerr << "Converting"
           << setw (7) << 0         <<"K of"
           << setw (7) << numlength <<"K\b"
           << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b"
           << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b";
    }

//         㯯  nradix .

    long lhigh = 0;                     // 襥 ᫮.
    if ((nr & 1) != 0) goto odd;        //  ᫮ - 襥.
    do
    {
//      ८ࠧ 襩 㯯  nradix .

      {
        long lb = 0;                    // .
        for(;;)
        {
          lb += chartonum [*ps++];
          assert (lb >= 0);
          if (--n == 0) break;
          lb *= radix;
        }
        n = nradix;
        lhigh = lb;                     // 襥 ᫮.
      }
      --nr;                             // ࠡ⠫ 㯯.

//      ८ࠧ 襩 㯯  nradix .

odd:  {
        long lb = 0;                    // .
        for(;;)
        {
          lb += chartonum [*ps++];
          assert (lb >= 0);
          if (--n == 0) break;
          lb *= radix;
        }
        n = nradix;
        num_ = lb;                      // 襥 ᫮.
      }
      --nr;                             // ࠡ⠫ 㯯.

//      ᫥ ⥫ ࢮ 浪.

      num_.addmul (lhigh, lradix);      // ꥤ ᫮.
      assert (num_ >= 0);

//      ᫥ ⥫ ண  ᫥ 浪
//        ᫠.

      for (size_t i = 1;; i++)
      {
        if (i < np)                     // ᫥ ⥫.
        {
           if ((nr & (2<<i)-1) != 0)    //  ⥫
           {                            // 
             num_.swap (mul [i]);       //  ⥪.
             break;
           }                            //   ⥫
                                        //  ᮪ 浪.
           num_.addmultab (powr [i], mul [i]);
           assert (num_ >= 0);
        }
        else                            //  ᫠.
        {
          if (numlength > 0)            // ண - .
          {
            cerr << "Converting"
                 << setw (7) << (numlength -
                                 nr / (1024 / sizeof (long)))
                                           <<"K of"
                 << setw (7) <<  numlength <<"K\b"
                 << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b"
                 << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b";
          }
          num_.addmultab (powr [i], *this);
          assert (num_ >= 0);
          num_.swap (*this);
          break;
        }
      }
    }
    while (nr != 0);

    if (numlength != 0)                 // ⪠ .
          cerr << "                             \b"
               << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b"
               << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b";
  }

//      ᫮ ८ࠧ.

  EXDEBUG (num_ = 0);                    // ⫠筮 㫥.
  return *this;
}

//      ⮤ ॢ ப   ᫮ ࠡ⠥  ᭮
//       2  16. ᫨ ᭮  㪠 (0),  ᭮
//      10, 8  16 롨ࠥ  䨪ᠬ 0, 0x  0X.

cBigNumber& cBigNumber::set (           // ८ࠧ  ப.
                const char *psz,        // 室 ப.
                unsigned radix          // ᭮ (2..16)  0.
            )                           // 0 -  ᮣ襭 몠 .
{
  assert (psz);
  assert (radix != 1);
  assert (radix <= MAX_RADIX);
  int sign = 0;                         //  ᫠.
  unsigned c = *psz++;                  // 騩 ᨬ.

//      ᯮ .

  switch (c)
  {
    case '-': sign = 1;
    case '+': c = *psz++;
  }

//      ᯮ ᭮.

  if (radix == 0)
  {
    radix = 10;
    if (c == '0')
    {
      c = *psz++; radix = 8;
      if (c == 'X' || c == 'x') { c = *psz++; radix = 16; }
    }
  }

//        ᫠.

  cBigNumberSqrTab (radix, 0, 0);       // 塞 chartonum.
  int len = 0;
  for (;;)
  {
    if ((size_t)chartonum [c] >= radix) break;
    c = psz [len++];                    // 騩 ᨬ.
  }
  --psz;

//      ஢ ᫠.

  set_ (EXPTRTO(char,psz,len), radix, len);

//      ᢮ .

  if (sign) this->neg();

  return *this;
}

//================================================
//        .
//================================================

//      ଠ஢  ஢  ᭮ ᫥ 䫠:
//      ios::skipws     ய 砫 ஡
//      ios::dec        ᫮  ᭮ 10
//      ios::oct        ᫮  ᭮ 8
//      ios::hex        ᫮  ᭮ 16

istream& operator >> (istream& is, cBigNumber& b)
{
  assert (&is);
  assert (&b);
  static exarray<char> str_;            // ᪠ ப.
  int sign = 0;                         //  ᫠.
  char c;                               // 騩 ᨬ.
  long flags = is.flags();              // .
  unsigned radix = (                    // ᭮.
         (flags & ios::dec)? 10:
         (flags & ios::oct)? 8:
         (flags & ios::hex)? 16: 0);

//       ࢮ ᨬ  ய᪮ ஡ ᨬ,
//      ᫨  ।ᬮ७ 䫠 ios::skipws.

  is >> c;

//      ᯮ .

  switch (c)
  {
    case '-': sign = 1;
    case '+': c = (char) is.get();
  }
  if (radix == 0)                       // ᯮ ᭮.
  {
    radix = 10;
    if (c == '0')
    {
      c = (char) is.get(); radix = 8;
      if (c == 'X' || c == 'x') { c = (char) is.get(); radix = 16; }
    }
  }

//       .

  cBigNumberSqrTab (radix, 0, 0);       // 塞 chartonum.
  int len = 0;
  for (;;)
  {
    if ((size_t)chartonum [(unsigned char)c] >= radix) break;
    str_ [len++] = c;
    c = (char) is.get();                // 騩 ᨬ.
  }
  if ((signed char)c != EOF)
  {
    is.putback (c);                     // 頥 ᯮ ᨬ.
  }
  str_ [len] = 0;                       //  ப.
  str_.checkshrink (len);

//      ஢ ᫠.

  b.set_ (EXPTRTYPE(str_), radix, len);

//      ᢮ .

  if (sign) b.neg();

  return is;
}

//================================================
//       ॢ ᫠  ப.
//================================================

//      ⮤ ॢ  ᫠  ப ࠡ⠥ 
//      ᭮  2  16  ਭ 䫠 ଠ஢
//      ⠭⭮  ios. ᫨ ᭮  㪠 (0),
//       ଠ஢ ஢  ᭮ ᫥ 䫠:
//      ios::internal     ᭮ ᫥, ᫮ ࠢ  
//                      ᨬ ios::fill()  ios::width() ᨬ.
//      ios::dec         ᫮  ᭮ 10 (㬮砭).
//      ios::oct         ᫮  ᭮ 8
//      ios::hex         ᫮  ᭮ 16
//      ios::showbase    ਧ ᭮ (0  0x)
//      ios::showpos    뢮   ⥫ ᥫ
//      ios::uppercase  ய 㪢  ᥫ  ᭮ > 10.
//      ᫨ ᭮ 㪠,  ᫮ 뢮   ଥ,
//       ⮬ 䫠 ios:dec, ios::oct, ios::hex .

//      ⮤ 뤠 㪠⥫   ப, 
//      ९뢠   ୮ 맮 ⮤.
//      ⮤   ⪠ ᫥ .

char*   cBigNumber::toatmp (            // ॢ  ப.
                unsigned radix,         // ᭮ (2..16)  0.
                ios& os                 // ଠ஢ ᫠  NULL.
        ) const                         // 뤠 㪠⥫  ᪨
{                                       // ନ஢ ப.
  assert (radix != 1);
  assert (radix <= MAX_RADIX);
  num_ = *this; num_.fit();             // ଠ.
  size_t i = 0;                         //   str_.
  long flags = (&os? os.flags(): 0);    //  ଠ஢ ios.
  static exarray<char> str_;            // ᪠ ப.

//      롮 ⠡ ४஢ .

  register const EXPTR(char) ps = EXPTRTO (char,
                         numtochar [(flags & ios::uppercase) != 0],
                         sizeof (numtochar [0]));

//      뢮   䨪ᮢ.

  {
    long sign = num_.comp0();

    if (radix == 0)                             // ᫨ ᭮  㪠,
    {                                           //  ⨯ ᫠  䫠.
      radix = ((flags & ios::hex)? 16: (flags & ios::oct)? 8: 10);
      if (radix != 10)                          // ᫨ ᭮ 8  16,
      {                                         //    뢮.
        if (sign < 0)
        {
          ++(num_.e[0]);                        // ⮡ ᫮ ⠫
          num_.checkexpand (num_.length());     // ⥫,
          num_.e [num_.length()] = 0;           //  0-᫮.
        }
        sign = 0;
      }
    }

    if (sign < 0)                                   // 뢮  '-'.
    {
      str_ [i++] = '-'; num_.neg();
    }
    else if (sign > 0 && (flags & ios::showpos))    // 뢮  '+'
    {
      str_ [i++] = '+';
    }

    if (radix % 8 == 0 && (flags & ios::showbase))  // 뢮 ᭮.
    {
      str_ [i++] = '0'; if (radix == 16) str_ [i++] = ps [16];
    }
  }

//      ନ஢ ᫠  ⭮ 浪.
//
//      室 (⨬஢)  룫廊 ⠪:
//      do
//      {
//        str_ [i++] = ps [num % radix];
//        num_ /= radix;
//      }
//      while (num_ != 0);
//
//       ⨬஢ ⬥   ਬ
//      ⮤ setdivmodtab, 뤠騩 ⭮  ⮪  ࠧ.
//       ᮪饭 ᫠   ਬ
//        樥 powradix, 祭 ⥬
//       ᭮ radix  楫o᫥ ⥯.
//
//       १   訩 ⥫  ᮬ npmax
//      ࠧ ⭮  ⮪,    ⥫
//       ᮬ npmax-1,  ..,   १  
//      訩 ⥫  ᮬ 0  ࠧ ᫠,
//      㪫뢠騥  ࠧ來  long,  ८ࠧ
//       ப ⥬ ᫥⥫쭮   radix.
//
//      襥 ⭮ ࠭  num_,  訥 
//       ⥪  div    ⥪ ਧ kdiv.
//      ਧ ࠢ 1, ᫨  ᮮ⢥饬  div
//      室 襥 ⭮. ࢮ砫쭮 ᨢ  .
//       襣 ⭮  ᮮ⢥饬   
//      ᨢ kdiv ᥣ 室 0.
//
//      
//      襥 ⭮     ⭮  num_ 
//      ⪠  div [npmax - 1]; div [npmax - 1]  c 
//      ⭮  div [npmax - 1]  ⪠  div [npmax - 2]  ..
//      ⪨ ⮪  ⭮   div [0] ८ࠧ 
//      ப;  室 ८ࠧ ⪠ ⭮ ࠭  div [0].
//      ⭮ div [1] ७  div [0]   
//      稭 c div [0], ⮬ div [2] ७  div [1] 
//        c div [1],  ..   襣 ⭮,
//       ந 㬥襭 npmax    .

  size_t j = i;                                 //  ࢮ .
  {
//       ⥪ 樥⮢ powradix [radix].
//      뤠 ॡ㥬 ᫮ 樥⮢.

    size_t np = cBigNumberSqrTab (radix, num_.length(), MAX_NP_OUT);
    EXPTR(cBigNumber) powr = EXPTRTYPE(powradix [radix]);

//      稥 ⥪.

    EXPTR(cBigNumber)  div = EXPTRTYPE(stk_);   // ⥪ .
    EXPTR(int)        kdiv = EXPTRTYPE(kstk_);  // ⥪ ਧ.

//        .
//      ८ࠧ  窨 ᫠, ஬ ᠬ ᫥ ⪠.

    int numlength = num_.length() / (1024 / sizeof (long));
    if (numlength < MIN_PROGR) numlength = 0;   //   .
    size_t npmax = np;                          //  襣 ⭮.
    for (;;)                                    //   .
    {
      if (np == npmax)                          // 襥 ⭮.
      {
        if (numlength > 0)                      // ண - .
        {
          cerr << "Formatting"
               << setw (7) << (numlength -
                             num_.length() / (1024 / sizeof (long)))
                                         <<"K of"
               << setw (7) <<  numlength <<"K\b"
               << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b"
               << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b";
        }

//        襥 ⭮   ᮮ⢥騩 ⥫.
//        ᫨ १  㫥   襣
//        ⥫  0,   襣 ⥫ 㬥蠥
//         横 ࠡ⪨ 襣 ⭮ .

        num_.swap (mod_);                       //  ⭮  num_
        num_.setdivmodtab (mod_, powr [np]);    //  ⪠  mod_.

        if (num_.comp0() == 0)                  // 襥 ⭮ 稫,
        {                                       // ⠫ 訩 ⮪.
          if (np == 0) break;                   // ᫨  ᫥ ⮪,
                                                //  横 稢.
          num_.swap (mod_);                     //  ⮪ ⠭
          npmax = --np;                         // 訬 ,
          numlength = -numlength;               //  
          assert (kdiv [np] == 0);              //  ᫥ ஫
          continue;                             //  .
        }
      }
      else                                      //  ⭮.
      {
        assert (np > 0);                        // ஫.
        assert (kdiv [np - 1] == 0);            // ஫.
        if (kdiv [np] == 0)                     // ᫨ ⭮ , 
        {                                       // 室  ᫥饬
          ++np; continue;                       //  設.
        }                                       // ᫨ ⭮ ,
        mod_.swap (div [np]);                   //  㦠 div [np] 
        kdiv [np] = 0;                          // 砥  ᢮.
      }

//        ⪠ -   ⪠  0,
//         ᮮ⢥騩 ⥫.

      for (; np != 0; np--)
      {
        assert (kdiv [np - 1] == 0);            // ஫.
        kdiv [np - 1] = 1;                      // ⠭ ਧ.
        div  [np - 1].setdivmodtab (mod_, powr [np - 1]);
                                                //  ⭮  div
      }                                         //  ⪠  mod_.

//       ࠡ⪨ 襣 ⪠  ⭮,
//       㪫뢠  । ࠧ來 ⪨ long.
//      訩 ⮪   mod_,  襥 ⭮ -  div [0],
//      ᫨  ⠬  ( ⠪ ᥣ, ஬  npmax == 0).

      {
        register long lnum;                     // ⪮ 楫.
        lnum = mod_.loword();                   // 뢮 ⪠.
        for (;;)                                //  믮
        {                                       //  2 ࠧ.
          register long knum = maxradix [radix] [1] - 1;
          do                                    // 뢮 knum .
          {
            str_ [i++] = ps [ (int) (lnum % radix) ];
            lnum /= radix;                      // 뢮 .
          }
          while (--knum != 0);

          assert (lnum >= 0);                   // ஢ઠ.
          assert (lnum < (long) radix);         // ஢ઠ.
          str_ [i++] = ps [(int)(lnum)];        // ᫥ .

          if (kdiv [0] == 0) break;             //  ⭮?
          lnum = div [0].loword();              // 뢮 ⭮.
          kdiv [0] = 0;                         // div [0] ᢮.
        }
      }

//      塞 横, 稭  ᠬ 襣 ⭮.

      np = (npmax != 0);
    }                                           //   .

//      뢮 ᫥ ⪠.

    {
      long lnum = mod_.loword();
      if (lnum != 0)                            // ⪨ ⮪.
      do
      {
        str_ [i++] = ps [(int) (lnum % radix)]; // 뢮 .
      }
      while ((lnum /= radix) != 0);
    }
    if (numlength != 0)                         // ⪠ .
          cerr << "                             \b"
               << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b"
               << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b";

//      뢮   㫥 ᥫ.

    if (i == j) str_ [i++] = ps [0];                  // ᫮ ࠢ 0,
  }

//      뢮 ᨬ-⥫  襭 ப.

  {
    assert (i > j);                   // ஫.
    if (flags & ios::internal)        // ଠ  ⥫?
    {
      size_t n = os.width();          // ਭ .
      char   c = os.fill();           // ⥫.
      while (i < n) str_ [i++] = c;   // 뢮 ⥫.
    }
    str_ [i--] = 0;                   // ப ⮢.
  }

//      ⠭ ᨬ.

  {
    register EXPTR(char) ps = EXPTRTYPE(str_);

    while (i > j)                     // ⠭ ᨬ.
    {
      char c = ps [j]; ps [j] = ps [i]; j++; ps [i] = c; i--;
    }
  }

//      ᫮ ନ஢.

  EXDEBUG (num_ = 0);                   // ⫠筮 㫥.
  EXDEBUG (mod_ = 0);                   // ⫠筮 㫥.
  return ((char *)(const char *)str_);  // 뤠 ப.
}

//================================================
//        .
//================================================

//      ଠ஢ 뢮 ஢  ᭮ ᫥ 䫠:
//      ios::width()    ਭ 
//      ios::fill()     ᨬ-⥫
//      ios::left       ࠢ 
//      ios::right      ࠢ ࠢ
//      ios::internal     ᭮ ᫥, ᫮ ࠢ
//      ios::dec         ᫮  ᭮ 10 (㬮砭).
//      ios::oct         ᫮  ᭮ 8
//      ios::hex         ᫮  ᭮ 16
//      ios::showbase    ਧ ᭮ (0  0x)
//      ios::showpos    뢮   ⥫ ᥫ
//      ios::uppercase  ய 㪢  ᥫ  ᭮ > 10.
//      ⮤   ⪠ ᫥ .

ostream& operator << (ostream& os, const cBigNumber& b)
{
  assert (&os);
  assert (&b);
  os << b.toatmp (0, os);
  return os;
}
